#DEFINE APPNAME "CalcZip "
#DEFINE APPPAGES 1

#include "DWEDIT.inc"
menu = SafeRam3
compfrom = SafeRam3+1
compto = saferam3+2
StartApp:
	B_CALL _clrLCDfull
	B_CALL _cleargbuf
	ld a,11
	ld l,0
	ld b,64
	ld c,10
	ld ix,titlepic
	call largesprite
	call fastcopy
	call invert
	B_CALL _getkey

mainmenuload:
	call menusetup
	call showmenu1
	jp menugetkey

menusetup:
	bcall(_clrLCDfull)
	set textInverse, (iy+textflags)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,menutop

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	res textInverse, (iy+textflags)

	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,menu1opt

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	ld a,0
	ld (curcol),a
	ld a,2
	ld (currow),a
	ld hl,menu2opt

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	ld a,0
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld hl,menu3opt

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	ret



menugetkey:
	B_CALL _Getcsc
	cp gup
	jp z,menuup
	cp gdown
	jp z,menudown
	cp gclear
	jp z,quit
	cp genter
	jp z,select
	cp g2nd
	jp z,select

	cp g2
	jp z,uninstallhook
	cp g1
	jp z,installhook
	cp g3
	jp z,quit
	jr menugetkey

menuup:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,menugetkey

	ld a,2
	cp l
	call z,showmenu1

	ld a,3
	cp l
	call z,showmenu2
	jp menugetkey


menudown:
	ld a,(menu)
	ld l,a
	ld a,3
	cp l
	jp z,menugetkey

	ld a,1
	cp l
	call z,showmenu2

	ld a,2
	cp l
	call z,showmenu3
	jp menugetkey

showmenu1:
	call menuclear
	set textInverse, (iy+textflags)
	ld a,1
	ld (menu),a
	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,menu1

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	res textInverse, (iy+textflags)
	ret

showmenu2:
	call menuclear
	set textInverse, (iy+textflags)
	ld a,2
	ld (menu),a
	ld a,0
	ld (curcol),a
	ld a,2
	ld (currow),a
	ld hl,menu2

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	res textInverse, (iy+textflags)
	ret

showmenu3:
	call menuclear
	set textInverse, (iy+textflags)
	ld a,3
	ld (menu),a
	ld a,0
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld hl,menu3

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	res textInverse, (iy+textflags)
	ret

select:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,getinfo

	ld a,2
	cp l
	jp z,unzipgetinfo

	ld a,3
	cp l
	jp z,quit
	jp quit

getinfo:
	B_CALL _clrLCDfull
	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,inputname

	ld de,op1
	b_call _strcopy
	ld hl,op1

	B_CALL _vputs


	ld a,0
	ld (curcol),a
	ld a,10
	ld (currow),a

	ld a,0
	ld b,8
	call getstr
	ld (compfrom),ix




	B_CALL _clrLCDfull
	ld a,0
	ld (curcol),a
	ld a,20
	ld (currow),a
	ld hl,inputnewname

	ld de,op1
	b_call _strcopy
	ld hl,op1

	B_CALL _vputs


	ld a,0
	ld (curcol),a
	ld a,30
	ld (currow),a

	ld a,0
	ld b,5
	call getstr
	ld (compto),ix

	call compressdata


















compressdata:
	ld  hl,(15h,compfrom)
	rst 20h
	B_CALL _ChkFindSym
	jp c,fromerror

	ld  hl,(15h,compto)
	rst 20h
	B_CALL _ChkFindSym
	jp nc,toerror

	






       ld ix,	      	;IX-> Sto to loc 
       ld bc,		;BC = Bytes to compress minus 1 
       ld hl,		;Compress from 
	call EnRLE
	jp mainmenuload









	ld hl,AppVarName
	rst 20h
	ld hl,500
	B_CALL _CreateAppVar 
	inc de 
	inc de 
	ld hl,	;what mem loc
	ld bc,	;size
	ldir 

getstr:
	xor a
	ld c,a			;c = length counter
	ld (op1),a		;mode 0 = CAPS
getstr1:
;ix = place to put string
;b = max legnth
	push bc
	push ix
	B_CALL getcsc
	pop ix
	pop bc
	or a
	jr z,getstr1
	cp 09h
	jr z,donestr		;enter pressed
	cp 0Fh
	push af
	call z,clear_all_input
	pop af
	jr z,getstr1
	cp 30h
	push af
	call z,next_keytable
	pop af
	jr z,getstr1
	cp 38h
	push af
	call z,del		;del pressed
	pop af
	jr z,getstr1
	ld e,a
	ld d,0
	call get_keytable
	add hl,de
	ld a,(hl)
	or a
	jr z,getstr1
	ld (ix+0),a
	inc ix
	inc c
	push bc
	push ix
	B_CALL vputmap
	pop ix
	pop bc
	djnz getstr1
donestr:
	ld a,c
	or a
	jr z,getstr1		;ya had to input SOMETHING!
	xor a
	ld (ix+0),a
	inc c			;c ends up returning the total
					;entered characters.
	ret			;done getting string
del:
	ld a,c
	or a
	ret z		;nothing to delete!
	inc b			;one more to enter
	dec c			;one less entered
	dec ix			;decrement ptr
	ld a,(ix+0)		;here comes the fun part
	ld l,a
	ld h,0
	add hl,hl		;a*2
	add hl,hl		;a*4
	add hl,hl		;a*8
	push bc
	push ix
	B_CALL sfont_len	;b = num pixels wide chr is
	ld d,b				;for some reason its b, not a (?)
	pop ix
	pop bc
	xor a
	ld (ix+0),a
	ld a,(pencol)
	sub d			;a - length
	ld (pencol),a
	push af
	push bc
	push ix
	ld b,d
	dec b
del_loop:
	ld a,20h
	B_CALL vputmap
	djnz del_loop
	pop ix
	pop bc
	pop af
	ld (pencol),a
	ret

clear_all_input:
	call del
	ld a,c
	or a
	jr nz,clear_all_input
	ret

get_keytable:
	push af
	ld a,(op1)
	ld hl,keytable_caps
	or a
	jr z,done_keytable_check
	ld hl,keytable_mini
	dec a
	jr z,done_keytable_check
	ld hl,keytable_num
	dec a
	jr z,done_keytable_check
	ld hl,keytable_caps
done_keytable_check:
	pop af
	ret

next_keytable:
	ld a,(op1)
	inc a
	cp 3
	jr c,no_reset_keytable
	xor a
no_reset_keytable:
	ld (op1),a
	ret

keytable_caps:
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 22h
	db 57h
	db 52h
	db 4Dh
	db 48h
	db 00h

	db 00h
	db 3Fh
	db 21h
	db 56h
	db 51h
	db 4Ch
	db 47h
	db 00h
	db 00h
	db 3Ah
	db 5Ah
	db 55h
	db 50h
	db 4Bh
	db 46h
	db 43h

	db 00h
	db 20h
	db 59h
	db 54h
	db 4Fh
	db 4Ah
	db 45h
	db 42h
	db 00h
	db 00h
	db 58h
	db 53h
	db 4Eh
	db 49h
	db 44h
	db 41h

	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h

keytable_mini:
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 22h
	db 77h
	db 72h
	db 6Dh
	db 68h
	db 00h

	db 00h
	db 3Fh
	db 21h
	db 76h
	db 71h
	db 6Ch
	db 67h
	db 00h
	db 00h
	db 3Ah
	db 7Ah
	db 75h
	db 70h
	db 6Bh
	db 66h
	db 63h

	db 00h
	db 20h
	db 79h
	db 74h
	db 6Fh
	db 6Ah
	db 65h
	db 62h
	db 00h
	db 00h
	db 78h
	db 73h
	db 6Eh
	db 69h
	db 64h
	db 61h

	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h

keytable_num:
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 2Bh ;+
	db 2Dh ;-
	db 2Ah ;*
	db 2Fh ;/
	db 5Eh ;^
	db 00h

	db 00h
	db 3Fh ;?
	db 33h ;3
	db 36h ;6
	db 39h ;9
	db 29h ;)
	db 00h
	db 00h
	db 00h
	db 2Eh ;.
	db 32h ;2
	db 35h ;5
	db 38h ;8
	db 28h ;(
	db 00h
	db 00h

	db 00h
	db 30h ;(space)
	db 31h ;1
	db 34h ;4
	db 37h ;7
	db 2Ch ;,
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h

	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h
	db 00h


Exit:
	B_CALL _clrLCDfull 
	bjump(_JForceCmdNoChar) 
	
vputs: 
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	B_CALL _vputmap
	jr vputs
puts:
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	B_CALL _putmap
	jr puts
 ;-----> Draw a sprite
; b=size of sprite
; l=yc
; a=xc
; ix holds pointer
putSprite:
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,gbuf
	add	hl,de
putSpriteLoop1:
sl1:	ld	d,(ix)
	ld	e,$00
	ld	a,c
	or	a
	jr	z,putSpriteSkip1
putSpriteLoop2:
	srl	d
	rr	e
	dec	a
	jr	nz,putSpriteLoop2
putSpriteSkip1:
	ld	a,(hl)
	xor	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	xor	e
	ld	(hl),a
	ld	de,$0B
	add	hl,de
	inc	ix
	djnz	putSpriteLoop1
	ret


;-----> Draw a picture
;Input:	ix->sprite
;	a=x
;	l=y
;	b=height	(in pixels)
;	c=width		(in bytes, e.g. 2 would be 16)
;Output: nothing
; All registers are destroyed except bc', de', hl'

largeSprite:
	di
	ex	af,af'
	ld	a,c
	push	af
	ex	af,af'
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,gbuf
	add	hl,de
largeSpriteLoop1:
	push	hl
largeSpriteLoop2:
	ld	d,(ix)
	ld	e,$00
	ld	a,c
	or	a
	jr	z,largeSpriteSkip1
largeSpriteLoop3:
	srl	d
	rr	e
	dec	a
	jr	nz,largeSpriteLoop3
largeSpriteSkip1:
	ld	a,(hl)
	xor	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	xor	e
	ld	(hl),a
	inc	ix
	ex	af,af'
	dec	a
	push	af
	ex	af,af'
	pop	af
	jr	nz,largeSpriteLoop2
	pop	hl
	pop	af
	push	af
	ex	af,af'
	ld	de,$0C
	add	hl,de
	djnz	largeSpriteLoop1
	pop	af
	ret

fastCopy:
	di
	ld	a,$80				; 7
	out	($10),a				; 11
	ld	hl,gbuf-12-(-(12*64)+1)		; 10
	ld	a,$20				; 7
	ld	c,a				; 4
	inc	hl				; 6 waste
	dec	hl				; 6 waste
fastCopyAgain:
	ld	b,64				; 7
	inc	c				; 4
	ld	de,-(12*64)+1			; 10
	out	($10),a				; 11
	add	hl,de				; 11
	ld	de,10				; 10
fastCopyLoop:
	add	hl,de				; 11
	inc	hl				; 6 waste
	inc	hl				; 6 waste
	inc	de				; 6
	ld	a,(hl)				; 7
	out	($11),a				; 11
	dec	de				; 6
	djnz	fastCopyLoop			; 13/8
	ld	a,c				; 4
	cp	$2B+1				; 7
	jr	nz,fastCopyAgain		; 10/1
	ret					; 10


;ENCRYPTING
EnRLE: 
EnRLENewNum: 
       ld     d,(hl)               ;D = last byte read 
       ld     e,1                  ;E = How many of current byte in a rwo 
EnRLELoop: 
       ld     a,b                  
       or     c 
       jr     z,EnRLEDone 
       inc    hl 
       ld     a,(hl) 
       dec    bc 

       cp     d 
       jr     nz,EnRLESto 
       inc    e 
       ld     a,e 
       inc    a                    ;If 255 in a row, we need to write *now* 
       jr     nz,EnRLELoop 
       dec    e 
EnRLESto: 
       ld     a,e 
       cp     4 
       jr     c,EnRLESto2 
EnRLEDoRLE: 
       ld     (ix),091h 
       inc    ix 
       ld     (ix),e 
       inc    ix 
       ld     (ix),d 
       inc    ix 
       jr     EnRLENewNum 
EnRLESto2: 
       ld     a,d 
       cp     091h 
       jr     z,EnRLEDoRLE 
       ld     (ix),d 
       inc    ix 
       dec    e 
       jr     z,EnRLENewNum 
       jr     EnRLESto2 
EnRLEDone: 
       dec    h 
       ret    z 
       ld     h,1 
       jr     EnRLESto

;END ENCRYPTING

invert:
gInverse:
	ld	bc,768		;the graph buffer is 768 bytes
	ld	hl,plotsscreen	;load the address for the graph buffer into hl
gInverseLoop:
	ld	a,(hl)		;load what is at (hl) (the graph buffer) into a
	cpl			;find the inverse of a
	ld	(hl),a		;load a back into (hl)
	inc	hl		;increment the current address in hl
	dec	bc		;decrement the counter
	ld	a,c		;load the lsb of the counter into a
	or	b		;or a with the msb of the counter
	jr	nz,gInverseLoop	;if a doesn't equal 0, goto gInverseLoop
	call fastcopy	;display the graph buffer on the lcd
	ret			;return to TI-OS

titlepic:
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$F8,$03,$80,$7E,$77,$E0,$00,$00
	.db $00,$01,$FC,$03,$80,$7E,$77,$F0,$00,$00
	.db $00,$01,$DC,$F3,$9E,$0E,$77,$70,$00,$00
	.db $00,$01,$C1,$FB,$BF,$1C,$77,$70,$00,$00
	.db $00,$01,$C0,$3B,$BF,$1C,$77,$F0,$00,$00
	.db $00,$01,$C0,$FB,$B8,$38,$77,$E0,$00,$00
	.db $00,$01,$DD,$FB,$BF,$70,$77,$00,$00,$00
	.db $00,$01,$FD,$FB,$BF,$7E,$77,$61,$C0,$00
	.db $00,$00,$F8,$FB,$9E,$7E,$77,$21,$40,$00
	.db $00,$00,$00,$00,$00,$00,$00,$75,$C0,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$E0,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00
	.db $00,$10,$00,$00,$00,$00,$00,$00,$80,$00
	.db $00,$10,$00,$00,$00,$00,$00,$00,$80,$00
	.db $00,$10,$00,$00,$00,$00,$00,$00,$80,$00
	.db $00,$11,$FC,$00,$00,$00,$03,$F0,$80,$00
	.db $00,$12,$02,$00,$00,$00,$04,$08,$80,$00
	.db $00,$12,$FA,$00,$00,$00,$37,$F4,$80,$00
	.db $00,$12,$8A,$00,$20,$40,$48,$14,$80,$00
	.db $00,$12,$FA,$00,$40,$20,$4F,$D4,$80,$00
	.db $00,$12,$02,$00,$FF,$F0,$40,$54,$80,$00
	.db $00,$13,$56,$01,$00,$08,$40,$54,$80,$00
	.db $00,$12,$02,$02,$00,$04,$40,$54,$80,$00
	.db $00,$13,$56,$01,$00,$08,$40,$54,$80,$00
	.db $00,$12,$02,$00,$FF,$F0,$7F,$F4,$80,$00
	.db $00,$13,$56,$00,$40,$20,$04,$04,$80,$00
	.db $00,$12,$02,$00,$20,$40,$03,$F8,$80,$00
	.db $00,$13,$56,$00,$00,$00,$00,$60,$80,$00
	.db $00,$12,$02,$00,$00,$00,$07,$FC,$80,$00
	.db $00,$11,$FC,$00,$00,$00,$00,$00,$80,$00
	.db $00,$10,$00,$00,$00,$00,$00,$00,$80,$00
	.db $00,$10,$00,$00,$00,$00,$00,$00,$80,$00
	.db $00,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $3C,$00,$08,$25,$00,$04,$20,$00,$00,$00
	.db $22,$00,$0C,$61,$00,$04,$40,$00,$00,$00
	.db $22,$8A,$0C,$65,$26,$04,$8E,$18,$63,$80
	.db $3E,$50,$0A,$A5,$49,$05,$09,$24,$92,$40
	.db $22,$50,$0A,$A5,$CF,$06,$89,$24,$92,$40
	.db $22,$50,$0A,$A5,$48,$04,$49,$24,$92,$40
	.db $3C,$22,$09,$25,$27,$04,$29,$18,$63,$80
	.db $00,$20,$00,$00,$00,$00,$00,$00,$02,$00
	.db $00,$40,$00,$00,$00,$00,$00,$00,$02,$00

AppVarName: 
	.db 15h,"Compress",0

menutop:
	.db "  CalcZip v1.0  ",0

menu1:
	.db "1:",0
menu1opt:
	.db "1:Zip Program",0
menu2:
	.db "2:",0
menu2opt:
	.db "2:Unzip Program",0
menu3:
	.db "3:",0
menu3opt:
	.db "3:Quit",0
inputname:
	.db "Input name of program:",0
inputnewname:
	.db "Input name of Zip file:",0









.end

	