#DEFINE APPNAME "KeyHook "
#DEFINE APPPAGES 1

#include "DWEDIT.inc"
AppVarObj	.EQU	  15h
menu = SafeRam1+1
key = SafeRam1
StartApp:
Setup:
	bcall(_clrLCDfull)
	set textInverse, (iy+textflags)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,title

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,author

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts


	res textInverse, (iy+textflags)

	ld b,0	;y1
	ld c,44	;x1
	ld d,96	;y2
	ld e,44	;x2
	ld h,1	;type of line 0=off  1=on  2=xor
	bcall(_Iline)

	ld b,0	;y1
	ld c,46	;x1
	ld d,96	;y2
	ld e,46	;x2
	ld h,1	;type of line 0=off  1=on  2=xor
	bcall(_Iline)

	ld b,0	;y1
	ld c,7	;x1
	ld d,96	;y2
	ld e,7	;x2
	ld h,1	;type of line 0=off  1=on  2=xor
	bcall(_Iline)

	ld a,58
	ld (penrow),a
	ld a,0
	ld (pencol),a
	ld hl,whattodo
	call  vputs

	ld a,1
	ld (menu),a
	jp hi1

showmenu:
	ld a,25
	ld (penrow),a
	ld a,17
	ld (pencol),a
	ld hl,menu1
	call  vputs

	ld a,32
	ld (penrow),a
	ld a,17
	ld (pencol),a
	ld hl,menu2
	call  vputs

	ld a,39
	ld (penrow),a
	ld a,17
	ld (pencol),a
	ld hl,menu3
	call  vputs

	ld a,46
	ld (penrow),a
	ld a,17
	ld (pencol),a
	ld hl,menu4
	call  vputs
	ret

menugetkey:
	bcall(_getk)
	cp G_clear
	jp z,quit
	cp G_2nd
	jp z,jumptoselect
	cp G_enter
	jp z,jumptoselect
	cp G_up
	jp z,selectup
	cp G_down
	jp z,selectdown
	cp G_1
	jp z,inputkey
	cp G_2
	jp z,general
	cp G_3
	jp z,credits
	cp G_4
	jp z,quit
	jp menugetkey

selectup:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,hi4
	ld a,2
	cp l
	jp z,hi1
	ld a,3
	cp l
	jp z,hi2
	ld a,4
	cp l
	jp z,hi3
	jp quit

selectdown:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,hi2
	ld a,2
	cp l
	jp z,hi3
	ld a,3
	cp l
	jp z,hi4
	ld a,4
	cp l
	jp z,hi1
	jp quit


hi1:
	call showmenu
	set textInverse, (iy+textflags)
	ld a,25
	ld (penrow),a
	ld a,17
	ld (pencol),a
	ld hl,menuh1
	call  vputs
	res textInverse, (iy+textflags)
	ld a,1
	ld (menu),a
	jp menugetkey

hi2:
	call showmenu
	set textInverse, (iy+textflags)
	ld a,32
	ld (penrow),a
	ld a,17
	ld (pencol),a
	ld hl,menuh2
	call  vputs
	res textInverse, (iy+textflags)
	ld a,2
	ld (menu),a
	jp menugetkey

hi3:
	call showmenu
	set textInverse, (iy+textflags)
	ld a,39
	ld (penrow),a
	ld a,17
	ld (pencol),a
	ld hl,menuh3
	call  vputs
	res textInverse, (iy+textflags)
	ld a,3
	ld (menu),a
	jp menugetkey

hi4:
	call showmenu
	set textInverse, (iy+textflags)
	ld a,46
	ld (penrow),a
	ld a,17
	ld (pencol),a
	ld hl,menuh4
	call  vputs
	res textInverse, (iy+textflags)
	ld a,4
	ld (menu),a
	jp menugetkey

jumptoselect:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,inputkey
	ld a,2
	cp l
	jp z,general
	ld a,3
	cp l
	jp z,credits
	ld a,4
	cp l
	jp z,quit
	jp quit


credits:
	jp quit

general:
	bcall(_clrLCDfull)
	
	ld a,0
	ld (penrow),a
	ld a,18
	ld (pencol),a
	ld hl,generalsettingtxt
	call  vputs

	ld b,0	;y1
	ld c,55	;x1
	ld d,96	;y2
	ld e,55	;x2
	ld h,1	;type of line 0=off  1=on  2=xor
	bcall(_Iline)

	jp ge1

generalmenu:
	ld a,10
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,general1
	call  vputs

	ld a,18
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,general2
	call  vputs

	ld a,26
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,general3
	call  vputs

	ld a,34
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,general4
	call  vputs

	ld a,42
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,general5
	call  vputs
	
	ld a,50
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,general6
	call  vputs
	ret

generalkey:
	bcall(_getk)
	cp G_Clear
	jp z,setup
	cp G_Up
	jp z,generalup
	cp G_Down
	jp z,generaldown
	cp G_2nd
	jp z,generalselect
	cp G_Enter
	jp z,generalselect
	cp G_1
	jp z,blockmem
	cp G_2
	jp z,hotkey
	cp G_3
	jp z,blockprgm
	cp G_4
	jp z,blockapp
	cp G_5
	jp z,screenshot
	cp G_6
	jp z,ostrich
	jp generalkey



;MENU START
generalup:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,ge6
	ld a,2
	cp l
	jp z,ge1
	ld a,3
	cp l
	jp z,ge2
	ld a,4
	cp l
	jp z,ge3
	ld a,5
	cp l
	jp z,ge4
	ld a,6
	cp l
	jp z,ge5
	jp quit

generaldown:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,ge2
	ld a,2
	cp l
	jp z,ge3
	ld a,3
	cp l
	jp z,ge4
	ld a,4
	cp l
	jp z,ge5
	ld a,5
	cp l
	jp z,ge6
	ld a,6
	cp l
	jp z,ge1
	jp quit


ge1:
	call generalmenu
	set textInverse, (iy+textflags)
	ld a,10
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,menuh1
	call  vputs
	res textInverse, (iy+textflags)
	ld a,1
	ld (menu),a
	jp generalkey

ge2:
	call generalmenu
	set textInverse, (iy+textflags)
	ld a,18
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,menuh2
	call  vputs
	res textInverse, (iy+textflags)
	ld a,2
	ld (menu),a
	jp generalkey


ge3:
	call generalmenu
	set textInverse, (iy+textflags)
	ld a,26
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,menuh3
	call  vputs
	res textInverse, (iy+textflags)
	ld a,3
	ld (menu),a
	jp generalkey


ge4:
	call generalmenu
	set textInverse, (iy+textflags)
	ld a,34
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,menuh4
	call  vputs
	res textInverse, (iy+textflags)
	ld a,4
	ld (menu),a
	jp generalkey


ge5:
	call generalmenu
	set textInverse, (iy+textflags)
	ld a,42
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,menuh5
	call  vputs
	res textInverse, (iy+textflags)
	ld a,5
	ld (menu),a
	jp generalkey


ge6:
	call generalmenu
	set textInverse, (iy+textflags)
	ld a,50
	ld (penrow),a
	ld a,10
	ld (pencol),a
	ld hl,menuh6
	call  vputs
	res textInverse, (iy+textflags)
	ld a,6
	ld (menu),a
	jp generalkey


generalselect:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,blockmem
	ld a,2
	cp l
	jp z,hotkey
	ld a,3
	cp l
	jp z,blockprgm
	ld a,4
	cp l
	jp z,blockapp
	ld a,5
	cp l
	jp z,screenshot
	ld a,6
	cp l
	jp z,ostrich
	jp quit

;MENU END































blockmem:
#include "blockmem.asm"
	jp generalkey

hotkey:
#include "hotkey.asm"
	jp generalkey

blockprgm:
#include "blckprgm.asm"
	jp generalkey

blockapp:
#include "blockapp.asm"
	jp generalkey

screenshot:
#include "scrshot.asm"
	jp generalkey

ostrich:
#include "ostrich.asm"
	jp generalkey













default:
	bcall(_clrLCDfull)
	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,defaultset

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts


	bcall(_getkey)

 

	LD         hl, hook_data ;label of hook, see below 
	IN         a, (6)
	bcall($4F6F)		;Disable Call RawKeyHook

	jp setup




;DATA
generalsettingtxt:
	.db "General KeyHooks",0

general1:	
	.db "1) Block Memory Access",0

general2:	
	.db "2) Prgm+App HotKey",0

general3:	
	.db "3) Reset All KeyHooks",0
general4:	
	.db "4) Block Apps Menu",0
general5:	
	.db "5) {LN} Screenshot",0
general6:	
	.db "6) Save the Ostriches",0







defaultset:
	.db "Defaults Set",0
install:
	.db "Hook Installed!",0
str1:
	.db "Waiting for key.",0
str2:
	.db "DONE!",0

quit:
	bcall(_clrLCDfull)
	bjump(_JForceCmdNoChar)

title:
	.db "KeyHook  Manager",0
author:
	.db "   Ti-83 Plus   ",0
whattodo:
	.db "By: Michael Knoop",0

menu1:
	.db "1) Disable a key",0
menu4:
	.db "4) Quit",0
menu2:
	.db "2) General Key Hooks",0
menu3: 
	.db "3) Credits",0
menuh1:
	.db "1)",0
menuh2:
	.db "2)",0
menuh3:
	.db "3)",0
menuh4:
	.db "4)",0
menuh5:
	.db "5)",0
menuh6:
	.db "6)",0

AppVarName: 
	.db AppVarObj,"HookInfo",0
installhot:
	.db "2nd+LN for apps",0
;END DATA


vputs: 
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	bcall(_VPutMap)
	jr vputs
puts:
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	bcall(_PutMap)
	jr puts

installed:
	ld a,0
	ld (pencol),a
	ld a,0
	ld (penrow),a
	ld hl,install

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	bcall(_getkey)
	jp setup



;no code other than keyhook after this

inputkey:
	bcall(_clrLCDfull)
	ld a,0
	ld (pencol),a
	ld a,0
	ld (penrow),a
	ld hl,str1

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

waitforkey:
	ld a,0
	ld (key),a
	bcall(_getkey)
	cp kclear
	jp z,quit
	ld l,a
	ld a,0
	cp l
	jp z,waitforkey

	ld a,l
	ld (key),a


installhotkey:
#include "hotkey2.asm"
installhotkey2:
	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,installhot

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts




loadtoappvar:
	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	jp c,intovar
	bcall(_delvar)



intovar:
	ld hl,AppVarName
	rst 20h
	ld hl,32
	B_CALL _CreateAppVar 
	inc de 
	inc de 
	ld hl,key
	ld bc,1
	ldir 
	jp loadkeyhook


loadkeyhook:
	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,str2

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts


	bcall(_getkey)

 

	LD         hl, hook_data ;label of hook, see below 
	IN         a, (6)
	bcall($4F66)		;Call RawKeyHook
	jp setup



hook_data: 
	ADD       a, e ;must have, OS checks for this.
	ld (key),a


	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	jp c,return
	inc de 
	inc de
	ex de, hl	
	ld  a, (hl)	;first byte
	ld l,a
	ld a,(hl)
	add a, l
	






	ld l,a
	ld a,(key)
	cp l
	jp nz,return
	xor a
	ret       ; exits hook 

return:
	ld a,(key)
	or a
	ret
