#DEFINE APPNAME "SignIn  "
#DEFINE APPPAGES 1

#include "DWEDIT.inc"
datasto = savesscreen
key = SafeRam3+1
penvar = SafeRam3+2
penvarb = SafeRam3+3
inputpass = SafeRam3+4
var = SafeRam3+5
StartApp:
	B_CALL _ClrLCDfull

	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	jp c,appmain
	inc de
	inc de 
	ex de, hl
	ld a, (hl)
	ld l,a
	ld a,1
	cp l
	jp z,password
	jp appmain

password:
	bcall(_clrLCDfull) 
	ld a,0
	ld (PENCOL),a
	ld (PENROW),a
	ld hl,passwordtxt
	call vputs
	ld a,6
	ld (PENROW),a
	ld a,0
	ld (PENCOL),a
	ld hl,passwordtxt2
	call vputs
	ld a,12
	ld (PENROW),a
	ld a,0
	ld (PENCOL),a
	ld hl,passwordtxt3
	call vputs
	bcall(_ZeroOP2) 
        	bcall(_ZeroOP1) 
	ld hl,OP1 
  	ld (hl),0

loop: 
	set ShiftAlpha,(iy+ShiftFlags)
	set ShiftAlock,(iy+ShiftFlags)
  	push hl
	ld a,18
	ld (PENROW),a
	ld a,0
	ld (PENCOL),a
  	ld hl,OP1
  	call vputs
  	bcall(_GetKey)  
	pop hl
	cp kClear
	jp z,Exit
  	cp kEnter 
 	jp z,passwordcheck
  	cp kdel 
 	jp z,Delete 
  	sub kCapA 
  	jp c,loop 
  	cp 26 
  	jp nc,loop 
	add a,'A'
  	ld (hl),a 
  	inc hl 
 	ld (hl),0 
  	jp loop 

Delete:
  	dec hl
  	ld (hl),20h
	dec hl
	push hl
	ld hl,cleartxt
	call vputs
	pop hl
	inc hl
	jp loop

passwordcheck:
	ld hl,OP1
	ld (inputpass),hl

	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	inc de
	inc de
	inc de
	inc de
	inc de
	inc de
	inc de
	inc de


	ld hl,(inputpass)

	
	ld a,40
	ld (PENROW),a
	ld a,0
	ld (PENCOL),a
	call vputsb
	B_CALL _Getkey

	B_CALL _CPHLDE



;	jp nz,password

	inc de

	inc hl

	ld a,40
	ld (PENROW),a
	ld a,5
	ld (PENCOL),a
	call vputsb
	B_CALL _Getkey

	B_CALL _CPHLDE
;	jp nz,password


	inc de

	inc hl

	ld a,40
	ld (PENROW),a
	ld a,10
	ld (PENCOL),a
	call vputsb
	B_CALL _Getkey

	B_CALL _CPHLDE
;	jp nz,password

	inc de

	inc hl

	ld a,40
	ld (PENROW),a
	ld a,15
	ld (PENCOL),a
	call vputsb
	B_CALL _Getkey

	B_CALL _CPHLDE
;	jp nz,password


appmain:	
	bcall(_clrLCDfull)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,tmaintop

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts


	ld a,10
	ld (pencol),a
	ld a,15
	ld (penrow),a
	ld hl,tinstall
	call vputs

	ld a,24
	ld (PENROW),a
	ld a,10
	ld (PENCOL),a
	ld hl,tpasswords
	call vputs


	ld a,33
	ld (PENROW),a
	ld a,10
	ld (PENCOL),a
	ld hl,tBanning
	call vputs

	ld a,42
	ld (PENROW),a
	ld a,10
	ld (PENCOL),a
	ld hl,texittxt
	call vputs


	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	jp c,showun
	inc de
	inc de 
	ld a, (de)
	ld l,a
	ld a,1
	cp l
	jp z,showin
	jp showun


showun:
	ld a,56
	ld (PENROW),a
	ld a,0
	ld (PENCOL),a
	ld hl,tun
	call vputs
	jp maincont

showin:
	ld a,56
	ld (PENROW),a
	ld a,0
	ld (PENCOL),a
	ld hl,tin
	call vputs

maincont:
	bcall(_getcsc)
	cp G_clear
	jp z,exit
	cp G_1
	jp z,install
	cp G_2
	jp z,passwords
	cp G_3
	jp z,banning
	cp G_4
	jp z,exit
	jp maincont
	




	



install:
	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	jp c,installhook
	inc de
	inc de
	ex de, hl
	ld a, (hl)
	ld l,a
	ld a,1
	cp l
	jp z,uninstallhook
	jp installhook







uninstallhook:
	bcall(_clrLCDfull)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,tunbig

	ld de,op1
	b_call _strcopy
	ld hl,OP1

	b_call _puts


	LD         hl, hook_data ;label of hook, see below 
	IN         a, (6)
	bcall($4F6F)		;Call RawKeyHook



	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	B_CALL _DelVar



	ld hl, AppVarName
	rst 20h
	ld hl,10
	B_CALL _CreateAppVar

	inc de
	inc de

	ld hl,uninstinfo	;what mem loc
	ld bc,1	;size
	ldir

	B_CALL _Getkey


	jp appmain


installhook:
	bcall(_clrLCDfull)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,tinputpass

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	LD         hl, hook_data ;label of hook, see below 
	IN         a, (6)
	bcall($4F66)		;Call RawKeyHook
	ld b,200
instdelay:
	djnz instdelay
	
	ld a,5
	ld (pencol),a
	ld a,15
	ld (penrow),a

	ld a,10
	ld (penvar),a
	ld a,0
	ld (penvarb),a
	
	call inputroutine
	ld hl,OP1
	ld a,(var)
	ld b,a
instmisc:
	dec hl
	djnz instmisc	


	ld af, hl

	

	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	jr c,inst_cont	
	B_CALL _Delvar


inst_cont:
	ld hl, AppVarName
	rst 20h
	ld hl,100
	B_CALL _CreateAppVar

	inc de
	inc de

	ld hl,instinfo	;what mem loc
	ld bc,5	;size
	ldir

	inc de

	ld hl, af	;what mem loc
	ld bc,25	;size
	ldir

	ld a,0
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld hl,tin

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	B_CALL _Getkey

	jp appmain





banning:
passwords:
Exit:
	bcall(_clrLCDfull)
	bjump(_JForceCmdNoChar) 
	
vputs: 
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	bcall(_VPutMap)
	jr vputs

vputsb: 
	ld a,(de) 
	inc de 
	or a 
	ret z 
	bcall(_VPutMap)
	jr vputsb
puts:
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	bcall(_PutMap)
	jr puts

inputroutine:
	bcall(_ZeroOP2) 
        	bcall(_ZeroOP1) 
	ld hl,OP1 
  	ld (hl),0

	ld a,0
	ld (var),a 

loopb: 
	set ShiftAlpha,(iy+ShiftFlags)
	set ShiftAlock,(iy+ShiftFlags)
  	push hl
	ld a,(penvar)
	ld (PENROW),a
	ld a,(penvarb)
	ld (PENCOL),a
  	ld hl,OP1 
  	call vputs
  	bcall(_GetKey)
	pop hl
	cp kClear
	jp z,Exit
  	cp kEnter 
 	ret z
  	cp kdel
 	jp z,Deleteb 
  	sub kCapA 
  	jp c,loopb 
  	cp 26 
  	jp nc,loopb 
	add a,'A'
  	ld (hl),a 
  	inc hl 
 	ld (hl),0

	ld a,(var)
	inc a
	ld (var),a 
  	jp loopb

Deleteb:
  	dec hl
  	ld (hl),20h
	dec hl
	push hl
	ld hl,cleartxt
	call vputs
	pop hl
	inc hl
	ld a,(var)
	dec a
	ld (var),a 
	jp loopb




tinputpass:
	.db "Master Password:",0
tmaintop:	
	.db "- SignIn  Main -",0
tinbig:
	.db "App Installed",0
tunbig:
	.db "App Uninstalled",0
tadmin:
	.db "Administrative",0
tmenu:
	.db "menu ",0
tinstall:
	.db "1: Install...",0
tin:
	.db "Installed",0
tun:
	.db "Uninstalled",0
tpasswords:
	.db "2: passwords",0
tBanning:
	.db "3: banning",0
texittxt:
	.db "4: exit",0
passwordtxt:
	.db "This application has been",0
passwordtxt2:
	.db "secured by a password.",0
passwordtxt3:
	.db "Please enter it now:",0
cleartxt:
	.db "     ",0
AppVarName: 
	.db 15h,"SignData",0
instinfo:
	.dw 1
uninstinfo:
	.dw 00



hook_data:		;start of the keyhook!
	ADD       a, e ;must have, OS checks for this.
	ld (key),a

;	bit shift2nd,(iy+shiftflags)	;Check if 2nd was pressed
;	jr z,hookcont
	ld a,(key)
	cp kclear
	jr nz,return

;	in a,(4)	;Check if ON pressed
;	bit 3,a
;	jr nz,hookcont

	ld a,1
	out (3),a		;turn power off
	halt

showstartup:
	set textInverse, (iy+textflags)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,thooktop
	ld de,op1
	b_call _strcopy
	ld hl,op1
	b_call _puts
	res textInverse, (iy+textflags)
	

hookcont:


return:
	ld a,(key)
	or a
	ret       ; exits hook 

thooktop:
	.db "  Please Login  ",0

.end

	