#DEFINE APPNAME "Zmenu   "
#DEFINE APPPAGES 1

#include "DWEDIT.inc"
menu = SafeRam3
dataload = SafeRam3+1
StartApp:
	B_CALL _ClrLCDfull

	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	jp c,install
	inc de
	ex de, hl
	ld a, (hl)
	ld l,a
	ld a,1
	cp l
	jp z,uninstall
	jp nocreateinstall

install:
	ld hl,AppVarName
	rst 20h
	ld hl,10
	B_CALL _CreateAppVar 
	inc de
	ld a,1
	ld (dataload),a
	ld hl,dataload	;what mem loc
	ld bc,10	;size
	ldir

installhook:
	LD         hl, hook_data ;label of hook, see below 
	IN         a, (6)
	bcall($4F66)		;Call RawKeyHook
	jp installquit

nocreateinstall:
	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	inc de
	ld a,1
	ld (dataload),a
	ld hl,dataload	;what mem loc
	ld bc,10	;size
	ldir
	jp installhook





uninstall:
	ld  hl, AppVarName 
	rst 20h
	B_CALL _ChkFindSym
	inc de
	ld a,0
	ld (dataload),a
	ld hl,dataload	;what mem loc
	ld bc,10	;size
	ldir

	LD         hl, hook_data ;label of hook, see below 
	IN         a, (6)
	bcall($4F6F)		;Call RawKeyHook

	jp uninstallquit
	

installquit:
	call showmainstuff

	ld a,12
	ld (pencol),a
	ld a,12
	ld (penrow),a
	ld hl,installtxt
	ld de,op1
	b_call _strcopy
	ld hl,op1
	b_call _vputs
	bcall(_getkey)
	
	jp exit
	
uninstallquit:
	call showmainstuff
	ld a,12
	ld (pencol),a
	ld a,12
	ld (penrow),a
	ld hl,uninstalltxt
	ld de,op1
	b_call _strcopy
	ld hl,op1
	b_call _vputs

	bcall(_getkey)
	
	
Exit:
	B_CALL _clrLCDfull 
	bjump(_JForceCmdNoChar) 




showmainstuff:
	ld hl,10*256+10
	ld de,10*256+70
	ld a,1
	B_CALL _Iline

	ld hl,10*256+71
	ld de,86*256+71
	ld a,1
	B_CALL _Iline

	ld hl,85*256+70
	ld de,85*256+10
	ld a,1
	B_CALL _Iline

	ld hl,85*256+9
	ld de,10*256+9
	ld a,1
	B_CALL _Iline

	ld a,0
	ld (pencol),a
	ld a,0
	ld (penrow),a
	ld hl,toptxt
	ld de,op1
	b_call _strcopy
	ld hl,op1
	b_call _vputs

	ld a,0
	ld (pencol),a
	ld a,57
	ld (penrow),a
	ld hl,bottxt
	ld de,op1
	b_call _strcopy
	ld hl,op1
	b_call _vputs


	ret




fastCopy:
	di
	ld	a,$80				; 7
	out	($10),a				; 11
	ld	hl,gbuf-12-(-(12*64)+1)		; 10
	ld	a,$20				; 7
	ld	c,a				; 4
	inc	hl				; 6 waste
	dec	hl				; 6 waste
fastCopyAgain:
	ld	b,64				; 7
	inc	c				; 4
	ld	de,-(12*64)+1			; 10
	out	($10),a				; 11
	add	hl,de				; 11
	ld	de,10				; 10
fastCopyLoop:
	add	hl,de				; 11
	inc	hl				; 6 waste
	inc	hl				; 6 waste
	inc	de				; 6
	ld	a,(hl)				; 7
	out	($11),a				; 11
	dec	de				; 6
	djnz	fastCopyLoop			; 13/8
	ld	a,c				; 4
	cp	$2B+1				; 7
	jr	nz,fastCopyAgain		; 10/1
	ret					; 10


	
	

quit:
	B_CALL _clrLCDfull 
	bjump(_JForceCmdNoChar) 
	


vputs: 
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	B_CALL _vputmap
	jr vputs
puts:
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	B_CALL _putmap
	jr puts


hook_data:
mainmenuload:
	call menusetup
	call showmenu1
	jp menugetkey

menusetup:
	bcall(_clrLCDfull)
	set textInverse, (iy+textflags)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,menutop

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	res textInverse, (iy+textflags)

	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,menu1opt

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	ld a,0
	ld (curcol),a
	ld a,2
	ld (currow),a
	ld hl,menu2opt

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	ld a,0
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld hl,menu3opt

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	ret



menugetkey:
	B_CALL _Getcsc
	cp gup
	jp z,menuup
	cp gdown
	jp z,menudown
	cp gclear
	jp z,quit
	cp genter
	jp z,select
	cp g2nd
	jp z,select

	cp g2
	jp z,menugetkey
	cp g1
	jp z,menugetkey
	cp g3
	jp z,quit
	jr menugetkey

menuup:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,menugetkey

	ld a,2
	cp l
	call z,showmenu1

	ld a,3
	cp l
	call z,showmenu2
	jp menugetkey


menudown:
	ld a,(menu)
	ld l,a
	ld a,3
	cp l
	jp z,menugetkey

	ld a,1
	cp l
	call z,showmenu2

	ld a,2
	cp l
	call z,showmenu3
	jp menugetkey

showmenu1:
	call menuclear
	set textInverse, (iy+textflags)
	ld a,1
	ld (menu),a
	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,menu1

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	res textInverse, (iy+textflags)
	ret

showmenu2:
	call menuclear
	set textInverse, (iy+textflags)
	ld a,2
	ld (menu),a
	ld a,0
	ld (curcol),a
	ld a,2
	ld (currow),a
	ld hl,menu2

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	res textInverse, (iy+textflags)
	ret

showmenu3:
	call menuclear
	set textInverse, (iy+textflags)
	ld a,3
	ld (menu),a
	ld a,0
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld hl,menu3

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	res textInverse, (iy+textflags)
	ret

select:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,installhook

	ld a,2
	cp l
	jp z,installhook

	ld a,3
	cp l
	jp z,quit
	jp quit

menuclear:
	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,menu1

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts


	ld a,0
	ld (curcol),a
	ld a,2
	ld (currow),a
	ld hl,menu2

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts


	ld a,0
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld hl,menu3

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	ret

menutop:
	.db "Menu List",0

menu1:
	.db "1:",0
menu1opt:
	.db "1:Install...",0
menu2:
	.db "2:",0
menu2opt:
	.db "2:Uninstall...",0
menu3:
	.db "3:",0
menu3opt:
	.db "3:Quit",0

uninst:
	.db "Uninstalled",0
inst:
	.db "Installed",0
toptxt:
	.db "Zmenu - Coded by Mike Knoop",0
bottxt:
	.db "Evlpoptart20@yahoo.com",0
installtxt:
	.db "Zmenu Installed...",0
uninstalltxt:
	.db "Zmenu Uninstalled...",0
AppVarName: 
	.db 15h,"Zmenuvar",0




.end

	