#DEFINE APPNAME "FireWall"
#DEFINE APPPAGES 1

#include "DWEDIT.inc"
menu = SafeRam3
key = SafeRam3+1
StartApp:
	B_CALL _clrLCDfull
	B_CALL _cleargbuf
	ld a,10
	ld l,0
	ld b,64
	ld c,10
	ld ix,titlepic
	call largesprite
	call fastcopy
	call invert
	ld b,200
mainscrdelay:
	djnz mainscrdelay
	

mainscrloop:
	B_CALL _getcsc
	ld l,0
	cp l
	jp z,mainscrloop	

mainmenuload:
	call menusetup
	call showmenu1
	jp menugetkey

menusetup:
	bcall(_clrLCDfull)
	set textInverse, (iy+textflags)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,menutop

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	res textInverse, (iy+textflags)

	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,menu1opt

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	ld a,0
	ld (curcol),a
	ld a,2
	ld (currow),a
	ld hl,menu2opt

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	ld a,0
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld hl,menu3opt

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	ret



menugetkey:
	B_CALL _Getcsc
	cp gup
	jp z,menuup
	cp gdown
	jp z,menudown
	cp gclear
	jp z,quit
	cp genter
	jp z,select
	cp g2nd
	jp z,select

	cp g2
	jp z,uninstallhook
	cp g1
	jp z,installhook
	cp g3
	jp z,quit
	jr menugetkey

menuup:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,menugetkey

	ld a,2
	cp l
	call z,showmenu1

	ld a,3
	cp l
	call z,showmenu2
	jp menugetkey


menudown:
	ld a,(menu)
	ld l,a
	ld a,3
	cp l
	jp z,menugetkey

	ld a,1
	cp l
	call z,showmenu2

	ld a,2
	cp l
	call z,showmenu3
	jp menugetkey

showmenu1:
	call menuclear
	set textInverse, (iy+textflags)
	ld a,1
	ld (menu),a
	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,menu1

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	res textInverse, (iy+textflags)
	ret

showmenu2:
	call menuclear
	set textInverse, (iy+textflags)
	ld a,2
	ld (menu),a
	ld a,0
	ld (curcol),a
	ld a,2
	ld (currow),a
	ld hl,menu2

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	res textInverse, (iy+textflags)
	ret

showmenu3:
	call menuclear
	set textInverse, (iy+textflags)
	ld a,3
	ld (menu),a
	ld a,0
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld hl,menu3

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts
	res textInverse, (iy+textflags)
	ret

select:
	ld a,(menu)
	ld l,a
	ld a,1
	cp l
	jp z,installhook

	ld a,2
	cp l
	jp z,uninstallhook

	ld a,3
	cp l
	jp z,quit
	jp quit


uninstallhook:
	bcall(_clrLCDfull)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,uninst

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts


	LD         hl, hook_data ;label of hook, see below 
	IN         a, (6)
	bcall($4F6F)		;Call RawKeyHook
	B_CALL _Getkey
	jp mainmenuload


installhook:
	bcall(_clrLCDfull)

	ld a,0
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,inst

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	LD         hl, hook_data ;label of hook, see below 
	IN         a, (6)
	bcall($4F66)		;Call RawKeyHook
	B_CALL _Getkey	
	jp mainmenuload

menuclear:
	ld a,0
	ld (curcol),a
	ld a,1
	ld (currow),a
	ld hl,menu1

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts


	ld a,0
	ld (curcol),a
	ld a,2
	ld (currow),a
	ld hl,menu2

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts


	ld a,0
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld hl,menu3

	ld de,op1
	b_call _strcopy
	ld hl,op1

	b_call _puts

	ret
	

quit:
	B_CALL _clrLCDfull 
	bjump(_JForceCmdNoChar) 
	


vputs: 
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	B_CALL _vputmap
	jr vputs
puts:
	ld a,(hl) 
	inc hl 
	or a 
	ret z 
	B_CALL _putmap
	jr puts


 ;-----> Draw a sprite
; b=size of sprite
; l=yc
; a=xc
; ix holds pointer
putSprite:
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,gbuf
	add	hl,de
putSpriteLoop1:
sl1:	ld	d,(ix)
	ld	e,$00
	ld	a,c
	or	a
	jr	z,putSpriteSkip1
putSpriteLoop2:
	srl	d
	rr	e
	dec	a
	jr	nz,putSpriteLoop2
putSpriteSkip1:
	ld	a,(hl)
	xor	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	xor	e
	ld	(hl),a
	ld	de,$0B
	add	hl,de
	inc	ix
	djnz	putSpriteLoop1
	ret


;-----> Draw a picture
;Input:	ix->sprite
;	a=x
;	l=y
;	b=height	(in pixels)
;	c=width		(in bytes, e.g. 2 would be 16)
;Output: nothing
; All registers are destroyed except bc', de', hl'

largeSprite:
	di
	ex	af,af'
	ld	a,c
	push	af
	ex	af,af'
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,gbuf
	add	hl,de
largeSpriteLoop1:
	push	hl
largeSpriteLoop2:
	ld	d,(ix)
	ld	e,$00
	ld	a,c
	or	a
	jr	z,largeSpriteSkip1
largeSpriteLoop3:
	srl	d
	rr	e
	dec	a
	jr	nz,largeSpriteLoop3
largeSpriteSkip1:
	ld	a,(hl)
	xor	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	xor	e
	ld	(hl),a
	inc	ix
	ex	af,af'
	dec	a
	push	af
	ex	af,af'
	pop	af
	jr	nz,largeSpriteLoop2
	pop	hl
	pop	af
	push	af
	ex	af,af'
	ld	de,$0C
	add	hl,de
	djnz	largeSpriteLoop1
	pop	af
	ret

fastCopy:
	di
	ld	a,$80				; 7
	out	($10),a				; 11
	ld	hl,gbuf-12-(-(12*64)+1)		; 10
	ld	a,$20				; 7
	ld	c,a				; 4
	inc	hl				; 6 waste
	dec	hl				; 6 waste
fastCopyAgain:
	ld	b,64				; 7
	inc	c				; 4
	ld	de,-(12*64)+1			; 10
	out	($10),a				; 11
	add	hl,de				; 11
	ld	de,10				; 10
fastCopyLoop:
	add	hl,de				; 11
	inc	hl				; 6 waste
	inc	hl				; 6 waste
	inc	de				; 6
	ld	a,(hl)				; 7
	out	($11),a				; 11
	dec	de				; 6
	djnz	fastCopyLoop			; 13/8
	ld	a,c				; 4
	cp	$2B+1				; 7
	jr	nz,fastCopyAgain		; 10/1
	ret					; 10




invert:
gInverse:
	ld	bc,768		;the graph buffer is 768 bytes
	ld	hl,plotsscreen	;load the address for the graph buffer into hl
gInverseLoop:
	ld	a,(hl)		;load what is at (hl) (the graph buffer) into a
	cpl			;find the inverse of a
	ld	(hl),a		;load a back into (hl)
	inc	hl		;increment the current address in hl
	dec	bc		;decrement the counter
	ld	a,c		;load the lsb of the counter into a
	or	b		;or a with the msb of the counter
	jr	nz,gInverseLoop	;if a doesn't equal 0, goto gInverseLoop
	call fastcopy	;display the graph buffer on the lcd
	ret			;return to TI-OS

titlepic:
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%01111110,%11001111,%11011111,%10110011,%11001100,%01100001,%10000110,%00000000,%00000000
	.db %00000000,%01100000,%11001100,%11011000,%00110011,%10011000,%11100001,%10000110,%00000000,%00000000
	.db %00000000,%01100000,%11001100,%11011000,%00011001,%10011000,%11110001,%10000110,%00000000,%00000000
	.db %00000000,%01100000,%11001111,%10011000,%00011011,%10110001,%10110001,%10000110,%00000000,%00000000
	.db %00000000,%01111110,%11001111,%00011111,%10011111,%10110001,%11111001,%10000110,%00000000,%00000000
	.db %00000000,%01100000,%11001101,%10011000,%00001110,%11100011,%00011001,%10000110,%00000000,%00000000
	.db %00000000,%01100000,%11001101,%11011000,%00001110,%11100011,%00011001,%10000110,%00000000,%00000000
	.db %00000000,%01100000,%11001100,%11011111,%10001100,%11000110,%00001101,%11110111,%11000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00100000,%01010001,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%01010110,%00011100,%00110101,%00010011,%00110000,%11100000,%00000000,%00000000
	.db %00000000,%00000000,%01010010,%00010100,%00101101,%01010101,%00010000,%10100000,%00000000,%00000000
	.db %00000000,%00000000,%00100111,%01011100,%00110111,%01010011,%00111010,%11100000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00001111,%11100000,%00001111,%01111011,%11011110,%00000000,%01111111,%00000000,%00000000
	.db %00000000,%00010000,%00010000,%00001001,%01001010,%01010010,%00000000,%10000000,%10000000,%00000000
	.db %00000000,%00010111,%11010000,%00001111,%01111011,%11011110,%00000000,%10111110,%10000000,%00000000
	.db %00000000,%00010100,%01010000,%00000000,%00000000,%00000000,%00000000,%10100010,%10000000,%00000000
	.db %00000000,%00010111,%11010000,%00001101,%11101111,%01111010,%00000000,%10111110,%10000000,%00000000
	.db %00000000,%00010000,%00010000,%00000101,%00101001,%01001010,%00000000,%10000000,%10000000,%00000000
	.db %00000000,%00011010,%10110000,%00001101,%11101111,%01111010,%00000000,%11010101,%10000000,%00000000
	.db %00000000,%00010000,%00010000,%00000000,%00000000,%00000000,%00000000,%10000000,%10000000,%00000000
	.db %00000000,%00011010,%10110000,%00001111,%01111011,%11011110,%00000000,%11010101,%10000000,%00000000
	.db %00000000,%00010000,%00010000,%00001001,%01001010,%01010010,%00000000,%10000000,%10000000,%00000000
	.db %00000000,%00011010,%10110000,%00001111,%01111011,%11011110,%00000000,%11010101,%10000000,%00000000
	.db %00000000,%00010000,%00010000,%00000000,%00000000,%00000000,%00000000,%10000000,%10000000,%00000000
	.db %00000000,%00011010,%10110000,%00000000,%01000000,%01000000,%00000000,%11010101,%10000000,%00000000
	.db %00000000,%00010000,%00010000,%00000000,%01000000,%01000000,%00000000,%10000000,%10000000,%00000000
	.db %00000000,%00001111,%11100000,%00000000,%01000000,%01000000,%00000000,%01111111,%00000000,%00000000
	.db %00000000,%00000001,%00000000,%00000000,%01000000,%01000000,%00000000,%00001000,%00000000,%00000000
	.db %00000000,%00000001,%11111111,%11111111,%11000000,%01111111,%11111111,%11111000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%01100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%01010101,%00001000,%10101101,%01001000,%10010000,%10100000,%00000000,%00000000,%00000000
	.db %00000000,%01100111,%01001101,%10001001,%01010101,%01010000,%11001110,%11101110,%11100000,%00000000
	.db %00000000,%01010010,%00001010,%10101001,%11011101,%10010000,%11001010,%10101010,%10100000,%00000000
	.db %00000000,%01100010,%01001000,%10101101,%01010100,%11010000,%10101010,%11101110,%11100000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%10000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%10000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000

AppVarName: 
	.db 15h," firewal",0

menutop:
	.db "FireWall Options",0

menu1:
	.db "1:",0
menu1opt:
	.db "1:Install...",0
menu2:
	.db "2:",0
menu2opt:
	.db "2:Uninstall...",0
menu3:
	.db "3:",0
menu3opt:
	.db "3:Quit",0

uninst:
	.db "Uninstalled",0
inst:
	.db "Installed",0



hook_data: 
	ADD       a, e ;must have, OS checks for this
	ld (key),a
checklink:
	in a,(0)	; check linkport
    	and 3		; upper bits are not important
    	cp 2
	jp z,showmess
	in a,(0)	; check linkport
    	and 3		; upper bits are not important
    	cp 1
	jp z,showmess
	in a,(0)	; check linkport
    	and 3		; upper bits are not important
    	cp 0
	jp z,showmess
	jp continue

showmess:
	ld hl,linkblock
puts2:
	ld a,(hl) 
	inc hl 
	or a 
	jr z,continue 
	B_CALL _putmap
	jr puts2

continue:
	ld a,0d0h	;load value of lines into a, set both low
	out (0),a
	ld l,$41
	ld a,(key)
	cp l
	jr nz,return
	ld a,0
	xor a
	ret       ; exits hook 

return:
	ld a,(key)
	ret
linkblock:
	.db "Firewall Active",0








;usefull appvar info:
;	ld  hl, AppVarName 
;	rst 20h
;	B_CALL _ChkFindSym
;	jp c,return
;	inc de 
;	inc de
;	ex de, hl	
;	ld  a, (hl)	;first byte
;	ld l,a
;	ld a,(hl)
;	add a, l
.end

	